#include "cdrip.h"

int lastcd,audioplaying=0,lasttrack=1;

void PlayAudio(int cd,int track)
{
  SRB_ExecSCSICmd esc;
  HANDLE ASPICompletionEvent;
  DWORD ASPIEventStatus;

  if ((ASPICompletionEvent = CreateEvent(NULL,FALSE,FALSE,NULL)) == NULL)
    return;
  esc.SRB_Cmd=SC_EXEC_SCSI_CMD;
  esc.SRB_HaId=cdrom[cd].ha_id;
  esc.SRB_Flags=SRB_DIR_OUT|SRB_EVENT_NOTIFY;
  esc.SRB_Hdr_Rsvd=0;
  esc.SRB_Target=cdrom[cd].scsi_id;
  esc.SRB_Lun=cdrom[cd].lun;
  esc.SRB_BufLen=0;
  esc.SRB_BufPointer=NULL;
  esc.SRB_SenseLen=SENSE_LEN;
  esc.SRB_CDBLen=10;
  esc.SRB_PostProc=ASPICompletionEvent;
  esc.SRB_CDBByte[0]=0x48;
  esc.SRB_CDBByte[1]=cdrom[cd].lun<<5;
  esc.SRB_CDBByte[2]=0;
  esc.SRB_CDBByte[3]=0;
  esc.SRB_CDBByte[4]=track;
  esc.SRB_CDBByte[5]=1;
  esc.SRB_CDBByte[6]=0;
  esc.SRB_CDBByte[7]=track;
  esc.SRB_CDBByte[8]=1;
  esc.SRB_CDBByte[9]=0;
  SendASPI32Command(&esc);
  ASPIEventStatus = WaitForSingleObject(ASPICompletionEvent, TIMEOUT);

  if (ASPIEventStatus == WAIT_OBJECT_0)
     ResetEvent(ASPICompletionEvent);
  CloseHandle(ASPICompletionEvent);
  if (esc.SRB_Status!=1 || esc.SRB_HaStat!=0 || esc.SRB_HaStat!=0)
  {
    Error(NULL,"PLAY AUDIO not supported!");
    audioplaying=0;
    return;
  }
  lastcd=cd;
  audioplaying=1;
  lasttrack=track;
  SendDlgItemMessage(g_hWnd,IDC_TRACKS,LB_SELITEMRANGE,FALSE,MAKELPARAM(0,99));
  SendDlgItemMessage(g_hWnd,IDC_TRACKS,LB_SETSEL,TRUE,track-1);
}

void StopAudio(void)
{
  SRB_ExecSCSICmd esc;
  HANDLE ASPICompletionEvent;
  DWORD ASPIEventStatus;

  if (audioplaying)
  {
    if ((ASPICompletionEvent = CreateEvent(NULL,FALSE,FALSE,NULL)) == NULL)
      return;
    esc.SRB_Cmd=SC_EXEC_SCSI_CMD;
    esc.SRB_HaId=cdrom[lastcd].ha_id;
    esc.SRB_Flags=SRB_DIR_OUT|SRB_EVENT_NOTIFY;
    esc.SRB_Hdr_Rsvd=0;
    esc.SRB_Target=cdrom[lastcd].scsi_id;
    esc.SRB_Lun=cdrom[lastcd].lun;
    esc.SRB_BufLen=0;
    esc.SRB_BufPointer=NULL;
    esc.SRB_SenseLen=SENSE_LEN;
    esc.SRB_CDBLen=10;
    esc.SRB_PostProc=ASPICompletionEvent;
    esc.SRB_CDBByte[0]=0x4B;
    esc.SRB_CDBByte[1]=cdrom[lastcd].lun<<5;
    esc.SRB_CDBByte[2]=0;
    esc.SRB_CDBByte[3]=0;
    esc.SRB_CDBByte[4]=0;
    esc.SRB_CDBByte[5]=0;
    esc.SRB_CDBByte[6]=0;
    esc.SRB_CDBByte[7]=0;
    esc.SRB_CDBByte[8]=0;
    esc.SRB_CDBByte[9]=0;
    SendASPI32Command(&esc);
    ASPIEventStatus = WaitForSingleObject(ASPICompletionEvent, TIMEOUT);

    if (ASPIEventStatus == WAIT_OBJECT_0)
       ResetEvent(ASPICompletionEvent);
    CloseHandle(ASPICompletionEvent);
    if (esc.SRB_Status!=1 || esc.SRB_HaStat!=0 || esc.SRB_HaStat!=0)
    {
//      Error(NULL,"Can't stop audio playback");
    }
    else
      audioplaying=0;
  }
}

void NextTrack(void)
{
  if (audioplaying)
  {
    if (lasttrack<toc.last_track)
      PlayAudio(lastcd,lasttrack+1);
  }
}

void PreviousTrack(void)
{
  if (audioplaying)
  {
    if (lasttrack>toc.first_track)
      PlayAudio(lastcd,lasttrack-1);
  }
}