#include <windowsx.h>
#include <direct.h>
#include "cdrip.h"

HWND      hWnd;
HWND      g_hWnd;
HINSTANCE hInst;
char      user_filter[255],filename[255],drive[4],h_filename[255];
int	      do_compare=1,use_tmpfile=0;
int       track,cd,max_speed=0,do_change=1,show_speed=1,autoskip=1,showspeed=0;
int       g_BUFSIZE=2000,g_NSECTORS=25,g_DSECTORS=25,g_directdisk=0;

void DisplayLastError(HWND hWnd)
{
  LPVOID lpMsgBuf;
  
  FormatMessage( 
    FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
    NULL,
    GetLastError(),
    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
    (LPTSTR) &lpMsgBuf,    0,    NULL );
  Error( hWnd, lpMsgBuf);
  LocalFree( lpMsgBuf );
}

long FAR PASCAL MainWndProc(HWND hWnd, unsigned message,WORD wParam, LONG lParam)
{
  switch (message) {
    case WM_CREATE: // Initialize Global vars
	    break;

    case WM_PAINT:
	    break;

    case WM_COMMAND:	// message: command from application menu
	    break;

    case WM_QUIT:
    case WM_DESTROY:	// message: window being destroyed
	    PostQuitMessage(0);
	    break;

    default:			// Passes it on if unproccessed
	    return (DefWindowProc(hWnd, message, wParam, lParam));
  }
  return 0;
}

void GetTotalSelected(HWND hWnd)
{
  int sc,tracksel[99],x;
  unsigned long low,high,totalsize,totaltime;
  char tmp[100],tmp2[100];
  DWORD spc,bps,fc,tc,free,freetime;

  sc=SendDlgItemMessage(g_hWnd,IDC_TRACKS,LB_GETSELCOUNT,0,0);
  totalsize=0;
	SendDlgItemMessage(g_hWnd,IDC_TRACKS,LB_GETSELITEMS,(WPARAM)99,(LPARAM)tracksel);
  for (x=0;x<sc;x++)
  {
	  low=toc.tracks[tracksel[x]].address1<<24|toc.tracks[tracksel[x]].address2<<16|toc.tracks[tracksel[x]].address3<<8|toc.tracks[tracksel[x]].address4;
	  high=toc.tracks[tracksel[x]+1].address1<<24|toc.tracks[tracksel[x]+1].address2<<16|toc.tracks[tracksel[x]+1].address3<<8|toc.tracks[tracksel[x]+1].address4;
    totalsize+=high-low;
  }
  totaltime=totalsize*SECTOR_SIZE/4L/44100L;
	GetDiskFreeSpace(drive,&spc,&bps,&fc,&tc);
	free=fc*spc*bps;
	if (free>1024L*1024L*1024L)
	  sprintf(tmp2,"%.1f G",(float)free/1024.0/1024.0/1024.0);
	else if (free>1024L*1024L)
	  sprintf(tmp2,"%.1f M",(float)free/1024.0/1024.0);
	else if (free>1024L)
	  sprintf(tmp2,"%.1f K",(float)free/1024.0);
	else
    sprintf(tmp2,"%lu bytes",free);
  freetime=free/4L/44100L;
  sprintf(tmp,"Tracks selected: %d, Size: %.1f M, Time: %02d:%02d",sc,(float)totalsize*(float)SECTOR_SIZE/1024.0/1024.0,(int)(totaltime/60),(int)(totaltime%60));
  SetDlgItemText(hWnd,IDC_TRACKS_SELECTED,tmp);
  sprintf(tmp,"Free disk space: %s, Free time: %02d:%02d",tmp2,(int)(freetime/60),(int)(freetime%60));
  SetDlgItemText(hWnd,IDC_FREE_SPACE,tmp);
}

void GetTargetFile(HWND hWnd,char *filename)
{
  OPENFILENAME openFile;
  char filter[100]="Wave Files (*.WAV)\0*.WAV\0All Files\0*.*\0\0\0",tmp[40];
  char path[_MAX_PATH];

  openFile.lStructSize=sizeof(OPENFILENAME);
  openFile.hwndOwner=hWnd;
  openFile.hInstance=NULL;
  openFile.lpstrFilter=filter;
  openFile.lpstrCustomFilter=user_filter;
  openFile.nMaxCustFilter=255;
  openFile.nFilterIndex=0;
  openFile.lpstrFile=filename;
  openFile.nMaxFile=512;
  openFile.lpstrFileTitle=NULL;
  openFile.nMaxFileTitle=0;
  openFile.lpstrInitialDir=NULL;
  openFile.lpstrTitle=NULL;
  openFile.Flags=OFN_OVERWRITEPROMPT|OFN_HIDEREADONLY;
  openFile.nFileOffset=0;
  openFile.nFileExtension=0;
  openFile.lpstrDefExt="wav";
  openFile.lCustData=0;
  openFile.lpfnHook=NULL;
  openFile.lpTemplateName=NULL;
  GetSaveFileName(&openFile);
  if (user_filter[1])
  {
    strcpy(tmp,&user_filter[strlen(user_filter)+1]);
    if (strcmp(strupr(tmp),"*.WAV"))
    {
      sprintf(user_filter,"Custom %s",tmp);
      strcpy(&user_filter[strlen(user_filter)+1],tmp);
    }
    else
      memset(user_filter,0,3);
  }
  _getcwd(path,_MAX_PATH);
  strncpy(drive,path,3);
  drive[3]=0;
  GetTotalSelected(hWnd);
}

void Error(HWND hWnd,char *str)
{
  MessageBox(hWnd,str,NULL,MB_OK|MB_ICONERROR);
}

BOOL FAR PASCAL AboutProc(HWND hWnd, unsigned message,WORD wParam, LONG lParam)
{
  switch (message) 
  {
    case WM_INITDIALOG:
      return TRUE;
    case WM_CLOSE:
      EndDialog(hWnd,TRUE);
      return TRUE;
    case WM_COMMAND:
      switch (wParam)
      {
	case IDOK: 
	  EndDialog(hWnd,TRUE);
	  return TRUE;
	default:
	  break;
      }
  }
  return FALSE;
}

void ShowSpeeds(HWND hWnd,int cd)
{
  char str[20];
  int x;

  do_change=0;
  SendDlgItemMessage(hWnd,IDC_MAX_SPEED,CB_RESETCONTENT,0,0);
  for (x=0;x<cdrom[cd].nspeeds;x++)
  {
    sprintf(str,"%2d X",cdrom[cd].speed[x]);
    SendDlgItemMessage(hWnd,IDC_MAX_SPEED,CB_INSERTSTRING,x,(LPARAM)str);
  }
  SendDlgItemMessage(hWnd,IDC_MAX_SPEED,CB_SETCURSEL,0,0);
  SendDlgItemMessage(hWnd,IDC_READ_METHOD,CB_SETCURSEL,cdrom[cd].readmethod,0);
  SendDlgItemMessage(hWnd,IDC_MODE_SELECT,CB_SETCURSEL,cdrom[cd].modeselect,0);
  SendDlgItemMessage(hWnd,IDC_SPEED_SELECT,CB_SETCURSEL,cdrom[cd].speedselect,0);
  if (show_speed)
  {
    if (cdrom[cd].nspeeds)
      sprintf(str,"%d",cdrom[cd].speed[0]);
    else
      strcpy(str,"0");
    SetDlgItemText(hWnd,IDC_CDSPEED,str);
  }
  SendDlgItemMessage(hWnd,IDC_BIG_ENDIAN,BM_SETCHECK,cdrom[cd].bigendian,0);
  SendDlgItemMessage(hWnd,IDC_JITTER,BM_SETCHECK,cdrom[cd].jitter,0);
  do_change=1;
}

void SetOptions(HWND hWnd)
{
  int cd;
  char str[20];

  if (do_change)
  {
    do_compare=SendDlgItemMessage(hWnd,IDC_COMPARE,BM_GETCHECK,1,0);
    use_tmpfile=SendDlgItemMessage(hWnd,IDC_TMPFILE,BM_GETCHECK,1,0);
    autoskip=SendDlgItemMessage(hWnd,IDC_AUTOSKIP,BM_GETCHECK,1,0);
    max_speed=SendDlgItemMessage(hWnd,IDC_MAX_SPEED,CB_GETCURSEL,0,0);
    GetDlgItemText(hWnd,IDC_BUFSIZE,str,20);
    g_BUFSIZE=abs(atoi(str));
    GetDlgItemText(hWnd,IDC_DISKSECTORS,str,20);
    g_DSECTORS=abs(atoi(str));
    GetDlgItemText(hWnd,IDC_CDSECTORS,str,20);
    g_NSECTORS=abs(atoi(str));
    g_directdisk=SendDlgItemMessage(hWnd,IDC_DIRECTDISK,BM_GETCHECK,1,0);
    showspeed=SendDlgItemMessage(hWnd,IDC_SHOWSPEED,BM_GETCHECK,1,0);
    cd=SendDlgItemMessage(hWnd,IDC_SOURCE,CB_GETCURSEL,0,0);
    if (g_DSECTORS > g_BUFSIZE)
      g_DSECTORS=g_BUFSIZE;
    if (g_NSECTORS > g_BUFSIZE)
      g_NSECTORS=g_BUFSIZE;
    if (cd!=CB_ERR)
    {
      cdrom[cd].readmethod=SendDlgItemMessage(hWnd,IDC_READ_METHOD,CB_GETCURSEL,0,0);
      cdrom[cd].modeselect=SendDlgItemMessage(hWnd,IDC_MODE_SELECT,CB_GETCURSEL,0,0);
      cdrom[cd].speedselect=SendDlgItemMessage(hWnd,IDC_SPEED_SELECT,CB_GETCURSEL,0,0);
      GetDlgItemText(hWnd,IDC_CDSPEED,str,20);
      CalculateSpeeds(cd,atoi(str));
      cdrom[cd].bigendian=SendDlgItemMessage(hWnd,IDC_BIG_ENDIAN,BM_GETCHECK,1,0);
      WriteCDSettings(cd,cdrom[cd].desc);
    }
  }
}

BOOL FAR PASCAL DlgProc(HWND hWnd, unsigned message,DWORD wParam, LONG lParam)
{
  FARPROC aboutproc;
  int tracksel[99];
  int pos,x,speed;
  char str[20];
  static UINT timer1;
  
  switch (message) 
  {
    case WM_INITDIALOG:
      SendMessage(hWnd,WM_SETICON,(WPARAM)ICON_BIG,(LPARAM)LoadIcon(hInst, MAKEINTRESOURCE(ICO_CDRIP)));
      SendMessage(hWnd,WM_SETICON,(WPARAM)ICON_SMALL,(LPARAM)LoadIcon(hInst, MAKEINTRESOURCE(ICO_CDRIP)));
      SendDlgItemMessage(hWnd,IDC_COMPARE,BM_SETCHECK,do_compare,0);
      SendDlgItemMessage(hWnd,IDC_TMPFILE,BM_SETCHECK,use_tmpfile,0);
      SendDlgItemMessage(hWnd,IDC_AUTOSKIP,BM_SETCHECK,autoskip,0);
      SendDlgItemMessage(hWnd,IDC_PLAY,BM_SETIMAGE,IMAGE_ICON,(LPARAM)LoadIcon(hInst,MAKEINTRESOURCE(IDI_PLAY)));
      SendDlgItemMessage(hWnd,IDC_STOP,BM_SETIMAGE,IMAGE_ICON,(LPARAM)LoadIcon(hInst,MAKEINTRESOURCE(IDI_STOP)));
      SendDlgItemMessage(hWnd,IDC_BACK,BM_SETIMAGE,IMAGE_ICON,(LPARAM)LoadIcon(hInst,MAKEINTRESOURCE(IDI_BACK)));
      SendDlgItemMessage(hWnd,IDC_NEXT,BM_SETIMAGE,IMAGE_ICON,(LPARAM)LoadIcon(hInst,MAKEINTRESOURCE(IDI_NEXT)));
      SendDlgItemMessage(hWnd,IDC_READ_METHOD,CB_INSERTSTRING,0,(LPARAM)"General");
      SendDlgItemMessage(hWnd,IDC_READ_METHOD,CB_INSERTSTRING,1,(LPARAM)"Plextor");
      SendDlgItemMessage(hWnd,IDC_READ_METHOD,CB_INSERTSTRING,2,(LPARAM)"Nec");
      SendDlgItemMessage(hWnd,IDC_READ_METHOD,CB_INSERTSTRING,3,(LPARAM)"Toshiba");
      SendDlgItemMessage(hWnd,IDC_READ_METHOD,CB_INSERTSTRING,4,(LPARAM)"Atapi");
      SendDlgItemMessage(hWnd,IDC_MODE_SELECT,CB_INSERTSTRING,0,(LPARAM)"General");
      SendDlgItemMessage(hWnd,IDC_MODE_SELECT,CB_INSERTSTRING,1,(LPARAM)"Toshiba/Dec");
      SendDlgItemMessage(hWnd,IDC_MODE_SELECT,CB_INSERTSTRING,2,(LPARAM)"None");
      SendDlgItemMessage(hWnd,IDC_MODE_SELECT,CB_INSERTSTRING,3,(LPARAM)"Atapi");
      SendDlgItemMessage(hWnd,IDC_SPEED_SELECT,CB_INSERTSTRING,0,(LPARAM)"Plextor");
      SendDlgItemMessage(hWnd,IDC_SPEED_SELECT,CB_INSERTSTRING,1,(LPARAM)"HP 4020");
      SendDlgItemMessage(hWnd,IDC_SPEED_SELECT,CB_INSERTSTRING,2,(LPARAM)"HP 6020");
      SendDlgItemMessage(hWnd,IDC_SPEED_SELECT,CB_INSERTSTRING,3,(LPARAM)"Generic");
      SendDlgItemMessage(hWnd,IDC_SPEED_SELECT,CB_INSERTSTRING,4,(LPARAM)"None");
      SendDlgItemMessage(hWnd,IDC_SPEED_SELECT,CB_INSERTSTRING,4,(LPARAM)"Atapi");
      sprintf(str,"%d",g_NSECTORS);
      SetDlgItemText(hWnd,IDC_CDSECTORS,str);
      sprintf(str,"%d",g_DSECTORS);
      SetDlgItemText(hWnd,IDC_DISKSECTORS,str);
      sprintf(str,"%d",g_BUFSIZE);
      SetDlgItemText(hWnd,IDC_BUFSIZE,str);
      SendDlgItemMessage(hWnd,IDC_DIRECTDISK,BM_SETCHECK,g_directdisk,0);
      SendDlgItemMessage(hWnd,IDC_SHOWSPEED,BM_SETCHECK,showspeed,0);
      g_hWnd=hWnd;
      GetCDRomDrives(hWnd);
	  for (x=0;x<n_cdrom;x++)
	    ReadCDSettings(x,cdrom[x].desc);
      ShowSpeeds(hWnd,0);
      GetTotalSelected(hWnd);
      timer1=SetTimer(hWnd,1,500,NULL);
      return TRUE;
    case WM_PAINT:
      break;
    case WM_CLOSE:
      PostQuitMessage(0);
      break;
    case WM_TIMER:
  	  if ((pos=SendDlgItemMessage(hWnd,IDC_SOURCE,CB_GETCURSEL,0,0))!=CB_ERR)
	    {
 	      ReadTOC(hWnd,pos,1);
      };
      break;
    case WM_COMMAND:
      switch (LOWORD(wParam))
      {
        case IDC_QUIT: 
	        PostQuitMessage(0);
    	    break;
     	  case IDC_GRAB:
	        x=SendDlgItemMessage(hWnd,IDC_TRACKS,LB_GETSELCOUNT,0,0);
	        if (x==0)
	        {
	          Error(hWnd,"No track selected");
	          break;
	        }
	        cd=SendDlgItemMessage(hWnd,IDC_SOURCE,CB_GETCURSEL,0,0);
	        if (cd==CB_ERR)
	        {
	          Error(hWnd,"No source selected");
	          break;
	        }
          SetOptions(hWnd);
	        h_filename[0]=0;
	        GetTargetFile(hWnd,h_filename);
          if (h_filename[0]==0)
            break;
	        StopAudio();
          KillTimer(hWnd,timer1);
          Working(GrabTrack,hWnd);
          GetTotalSelected(hWnd);
          timer1=SetTimer(hWnd,1,500,NULL);
 	        break;
	      case IDC_ABOUT:
	        aboutproc=MakeProcInstance((FARPROC)AboutProc,hInst);
	        DialogBox(hInst,MAKEINTRESOURCE(IDD_ABOUT),hWnd,(DLGPROC)aboutproc);
	        FreeProcInstance(aboutproc);
	        break;
	      case IDC_SOURCE:
	        if (HIWORD(wParam)==CBN_SELCHANGE)
	        {
/*            for (x=0;x<n_cdrom;x++)
              WriteCDSettings(x,cdrom[x].desc);*/
  	        if ((pos=SendDlgItemMessage(hWnd,IDC_SOURCE,CB_GETCURSEL,0,0))!=CB_ERR)
	          {
	            StopAudio();
 	            ReadTOC(hWnd,pos,0);
	            ShowSpeeds(hWnd,pos);
	            SendDlgItemMessage(hWnd,IDC_JITTER,BM_SETCHECK,cdrom[pos].jitter,0);
	          }
	        }
	        break;
	      case IDC_TRACKS:
          if (HIWORD(wParam)==LBN_DBLCLK)
	          SendMessage(hWnd,WM_COMMAND,IDC_GRAB,0);
          else if (HIWORD(wParam)==LBN_SELCHANGE || HIWORD(wParam)==LBN_SELCANCEL)
            GetTotalSelected(hWnd);
	        break;
	      case IDC_JITTER:
  	      if ((pos=SendDlgItemMessage(hWnd,IDC_SOURCE,CB_GETCURSEL,0,0))!=CB_ERR)
            cdrom[pos].jitter=SendDlgItemMessage(hWnd,IDC_JITTER,BM_GETCHECK,1,0);
          break;
	      case IDC_PLAY:
	        x=SendDlgItemMessage(hWnd,IDC_TRACKS,LB_GETSELCOUNT,0,0);
	        if (x==0)
	          tracksel[0]=0;
  	      if ((pos=SendDlgItemMessage(hWnd,IDC_SOURCE,CB_GETCURSEL,0,0))!=CB_ERR)
	        {
  	        SendDlgItemMessage(hWnd,IDC_TRACKS,LB_GETSELITEMS,(WPARAM)99,(LPARAM)tracksel);
            PlayAudio(pos,tracksel[0]+1);
	        }
	        break;
	      case IDC_STOP:
	        StopAudio();
	        break;
	      case IDC_NEXT:
	        NextTrack();
	        break;
	      case IDC_BACK:
	        PreviousTrack();
	        break;
	      case IDC_READ_METHOD:case IDC_MODE_SELECT:case IDC_SPEED_SELECT:case IDC_BIG_ENDIAN:
          SetOptions(hWnd);
          break;
	      case IDC_CDSPEED:
	        if (HIWORD(wParam)==EN_CHANGE)
	        {
	          show_speed=0;
	          SetOptions(hWnd);
	          pos=SendDlgItemMessage(hWnd,IDC_SOURCE,CB_GETCURSEL,0,0);
	          if (pos!=CB_ERR)
	            ShowSpeeds(hWnd,SendDlgItemMessage(hWnd,IDC_SOURCE,CB_GETCURSEL,0,0));
	          show_speed=1;
	        }
	        break;
	      case IDC_SETSPEED:
          speed=SendDlgItemMessage(hWnd,IDC_MAX_SPEED,CB_GETCURSEL,0,0);
  	      if ((pos=SendDlgItemMessage(hWnd,IDC_SOURCE,CB_GETCURSEL,0,0))!=CB_ERR)
	        {
            SetSpeed(cd,cdrom[cd].speed[speed]);
          }
          break;
        default:
	        break;
      }
      break;
  }
  return FALSE;
}

BOOL InitApplication(HINSTANCE hInstance)
{
  WNDCLASSEX  wc;

  // Fill in window class structure with parameters that describe the
  // main window.

  wc.cbSize=sizeof(WNDCLASSEX);
  wc.style = CS_HREDRAW | CS_VREDRAW;	// Class style(s).
  wc.lpfnWndProc = (WNDPROC)MainWndProc;	// Function to retrieve messages for
													  // windows of this class.
  wc.cbClsExtra = 0;	// No per-class extra data.
  wc.cbWndExtra = 0;	// No per-window extra data.
  wc.hInstance = hInstance;	// Application that owns the class.
  wc.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(ICO_CDRIP));
  wc.hIconSm = LoadIcon(hInstance, MAKEINTRESOURCE(ICO_CDRIP));
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = GetStockObject(WHITE_BRUSH);
  wc.lpszMenuName = NULL;	// Name of menu resource in .RC file.
  wc.lpszClassName = "CDRIP";	// Name used in call to CreateWindow.

  /* Register the window class and return success/failure code. */

  return (RegisterClassEx(&wc));
}

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND	hWnd;	// Main window handle.


	/* Create a main window for this application instance.  */

	hWnd = CreateWindow(
		"CDRIP", 	               // See RegisterClass() call.
		"Audio CD ripper",	  	      // Text for window title bar.
		WS_OVERLAPPEDWINDOW,	      // Window style.
		CW_USEDEFAULT, 			   // Default horizontal position.
		CW_USEDEFAULT,	   	   	// Default vertical position.
		CW_USEDEFAULT,	      		// Default width.
		CW_USEDEFAULT, 		   	// Default height.
		NULL,		   		         // Overlapped windows have no parent.
		NULL,	   			         // Use the window class menu.
		hInstance,  			      // This instance owns this window.
		NULL			   	         // Pointer not needed.
	);

	/* If window could not be created, return "failure" */

	if (!hWnd)
		return (FALSE);

	/* Make the window visible; update its client area; and return "success" */

//      ShowWindow(hWnd, nCmdShow);	// Show the window
//	UpdateWindow(hWnd);			// Sends WM_PAINT message
	return (TRUE);				// Returns the value from PostQuitMessage

}

BOOL InitDialog(HWND hWnd,HINSTANCE hInstance,int nCmdShow)
{
  FARPROC dlgproc;
  
  dlgproc=MakeProcInstance((FARPROC)DlgProc,hInst);
	  DialogBox(hInst,MAKEINTRESOURCE(IDD_CDRIP),hWnd,(DLGPROC)dlgproc);
	  FreeProcInstance(dlgproc);
  return TRUE;
}

void WriteToRegistry(char *key,char *subkey,DWORD type,char *value)
{
  HKEY hk;
  DWORD dp;
  int sz;

  if (type==REG_SZ)
    sz=strlen(value)+1;
  else if (type==REG_MULTI_SZ)
    sz=strlen(value)+strlen(&value[strlen(value)+1])+4;
  if (RegCreateKeyEx(
      HKEY_LOCAL_MACHINE,
      key,
      0,
      "REG_SZ",
      REG_OPTION_NON_VOLATILE,
      KEY_ALL_ACCESS,
      NULL,
      &hk,
      &dp)!=ERROR_SUCCESS)
    return;
  RegSetValueEx(hk,subkey,0,type,value,sz);
  RegCloseKey(hk);
}

BOOLEAN ReadFromRegistry(char *key,char *subkey,char *value)
{
  HKEY hk;
  DWORD sz=255,type;

  if (RegOpenKeyEx(
      HKEY_LOCAL_MACHINE,
      key,
      0,
      KEY_ALL_ACCESS,
      &hk)!=ERROR_SUCCESS)
    return FALSE;
  if (RegQueryValueEx(hk,subkey,0,&type,value,&sz)!=ERROR_SUCCESS)
  {
    RegCloseKey(hk);
    return FALSE;
  }
  RegCloseKey(hk);
  return TRUE;
}

void ReadCDSettings(int cd,char *desc)
{
  char str[100];
  char tmp[40];

  sprintf(str,"SOFTWARE\\CDRIP\\%s",desc);
  if (ReadFromRegistry(str,"ReadMethode",tmp))
    cdrom[cd].readmethod=atoi(tmp);
  if (ReadFromRegistry(str,"ModeSelect",tmp))
    cdrom[cd].modeselect=atoi(tmp);
  if (ReadFromRegistry(str,"SpeedSelect",tmp))
    cdrom[cd].speedselect=atoi(tmp);
  if (ReadFromRegistry(str,"MaxSpeed",tmp))
    CalculateSpeeds(cd,atoi(tmp));
  if (ReadFromRegistry(str,"BigEndian",tmp))
    cdrom[cd].bigendian=atoi(tmp);
/*  if (ReadFromRegistry(str,"JitterCorrection",tmp))
    cdrom[cd].jitter=atoi(tmp);*/
}

void WriteCDSettings(int cd,char *desc)
{
  char str[100];
  char tmp[40];

  sprintf(str,"SOFTWARE\\CDRIP\\%s",desc);
  sprintf(tmp,"%d",cdrom[cd].readmethod);
  WriteToRegistry(str,"ReadMethode",REG_SZ,tmp);
  sprintf(tmp,"%d",cdrom[cd].modeselect);
  WriteToRegistry(str,"ModeSelect",REG_SZ,tmp);
  sprintf(tmp,"%d",cdrom[cd].speedselect);
  WriteToRegistry(str,"SpeedSelect",REG_SZ,tmp);
  sprintf(tmp,"%d",cdrom[cd].speed[0]);
  WriteToRegistry(str,"MaxSpeed",REG_SZ,tmp);
  sprintf(tmp,"%d",cdrom[cd].bigendian);
  WriteToRegistry(str,"BigEndian",REG_SZ,tmp);
  sprintf(tmp,"%d",cdrom[cd].jitter);
  WriteToRegistry(str,"JitterCorrection",REG_SZ,tmp);
}

int PASCAL WinMain( HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
  MSG msg;			// message
  char tmp[255],path[_MAX_PATH];
  int x;

  if (!hPrevInstance)	// Other instances of app running?
    if (!InitApplication(hInstance))	// Initialize shared things
      return (FALSE);	// Exits if unable to initialize

  /* Perform initializations that apply to a specific instance */

  hInst=hInstance;
  if (ReadFromRegistry("SOFTWARE\\CDRIP","Verify",tmp))
    do_compare=atoi(tmp);
  if (ReadFromRegistry("SOFTWARE\\CDRIP","TmpFile",tmp))
    use_tmpfile=atoi(tmp);
  if (ReadFromRegistry("SOFTWARE\\CDRIP","AutoSkip",tmp))
    autoskip=atoi(tmp);
  user_filter[0]=0;
  ReadFromRegistry("SOFTWARE\\CDRIP","CustomFilter",user_filter);
  if (ReadFromRegistry("SOFTWARE\\CDRIP","WorkingDir",path))
    _chdir(path);
  else
    _getcwd(path,_MAX_PATH);
  strncpy(drive,path,3);
  drive[3]=0;
  if (ReadFromRegistry("SOFTWARE\\CDRIP","BufSize",tmp))
    g_BUFSIZE=atoi(tmp);
  if (ReadFromRegistry("SOFTWARE\\CDRIP","DiskSectors",tmp))
    g_DSECTORS=atoi(tmp);
  if (ReadFromRegistry("SOFTWARE\\CDRIP","CDSectors",tmp))
    g_NSECTORS=atoi(tmp);
  if (ReadFromRegistry("SOFTWARE\\CDRIP","DirectDisk",tmp))
    g_directdisk=atoi(tmp);
  if (ReadFromRegistry("SOFTWARE\\CDRIP","ShowSpeed",tmp))
    showspeed=atoi(tmp);

  if (!InitInstance(hInstance, nCmdShow))
    return (FALSE);

  if (!InitializeASPI())
    return -1;

  if (!InitDialog(hWnd,hInstance,nCmdShow))
    return FALSE;

  /* Acquire and dispatch messages until a WM_QUIT message is received. */

  while (GetMessage(&msg,	// message structure
	  NULL,	// handle of window receiving the message
	  0,	// lowest message to examine
	  0)==1)	// highest message to examine
  {
  TranslateMessage(&msg);	// Translates virtual key codes
  DispatchMessage(&msg);	// Dispatches message to window
  }
  StopAudio();
  sprintf(tmp,"%d",do_compare);
  WriteToRegistry("SOFTWARE\\CDRIP","Verify",REG_SZ,tmp);
  sprintf(tmp,"%d",use_tmpfile);
  WriteToRegistry("SOFTWARE\\CDRIP","TmpFile",REG_SZ,tmp);
  sprintf(tmp,"%d",autoskip);
  WriteToRegistry("SOFTWARE\\CDRIP","AutoSkip",REG_SZ,tmp);
  WriteToRegistry("SOFTWARE\\CDRIP","CustomFilter",REG_MULTI_SZ,user_filter);
  _getcwd(path,_MAX_PATH);
  WriteToRegistry("SOFTWARE\\CDRIP","WorkingDir",REG_SZ,path);
  sprintf(tmp,"%d",g_BUFSIZE);
  WriteToRegistry("SOFTWARE\\CDRIP","BufSize",REG_SZ,tmp);
  sprintf(tmp,"%d",g_NSECTORS);
  WriteToRegistry("SOFTWARE\\CDRIP","CDSectors",REG_SZ,tmp);
  sprintf(tmp,"%d",g_DSECTORS);
  WriteToRegistry("SOFTWARE\\CDRIP","DiskSectors",REG_SZ,tmp);
  sprintf(tmp,"%d",g_directdisk);
  WriteToRegistry("SOFTWARE\\CDRIP","DirectDisk",REG_SZ,tmp);
  sprintf(tmp,"%d",showspeed);
  WriteToRegistry("SOFTWARE\\CDRIP","ShowSpeed",REG_SZ,tmp);
  for (x=0;x<n_cdrom;x++)
    WriteCDSettings(x,cdrom[x].desc);
  DisposeASPI();
  return (msg.wParam);	// Returns the value from PostQuitMessage
}

