#include "cdrip.h"
#include <time.h>
#include <stdarg.h>


HINSTANCE lInst;
int luns,stopthread2=0;
CDROM cdrom[MAX_CDROM];
int n_cdrom=0;
TOC toc;
char *buffer,tmp[50],*oldbuf;
int firstpos=0,lastpos=0;
HANDLE f1,f2;
int chks=0,same=0,error=0,skipverify=0,skiperror=0,synchronized=0,skipfile=0;
int thread2stopped=0;
unsigned long curpos=0,low,high,extra=0;
unsigned long x,seconds;
DWORD start_time,end_time;
int speed=8,actualspeed,remaining;
float elapsed,progress,last_progress;
HANDLE decrease_sem,increase_sem;
int qsize=0;

void Log(char *str,...)
{
/*  FILE *f;
  va_list arg;

  va_start(arg,str);
  f=fopen("f:\\cdrip.log","a+");
  vfprintf(f,str,arg);
  fclose(f);
  va_end(arg);*/
}

int InitializeASPI(void)
{
  if ((lInst=LoadLibrary("wnaspi32.dll"))==NULL)
  {
    Error(NULL,"Can't load library WNASPI32.DLL");
    return 0;
  }
  GetASPI32SupportInfo=GetProcAddress(lInst,"GetASPI32SupportInfo");
  if (GetASPI32SupportInfo==NULL)
  {
    Error(NULL,"Can't load function GetASPI32SupportInfo()");
    return 0;
  }
  SendASPI32Command=GetProcAddress(lInst,"SendASPI32Command");
  if (SendASPI32Command==NULL)
  {
    Error(NULL,"Can't load function SendASPI32Command()");
    return 0;
  }
  return 1;
}

void DisposeASPI(void)
{
  FreeLibrary(lInst);
}

int SetSpeed(int cd,int speed)
{
  SRB_ExecSCSICmd esc;
  HANDLE ASPICompletionEvent;
  DWORD ASPIEventStatus;
  char hpbuf[12]={0x00,0x00,0x00,0x00,0x23,0x06,0x00,0x00,0x00,0x00,0x00,0x00};
  char plextorbuf[8]={0x00,0x00,0x00,0x00,0x31,0x02,0x00,0x00};
  int kspeed;

  if (cdrom[cd].speedselect==SL_PLEXTOR)
  {
    if ((ASPICompletionEvent = CreateEvent(NULL,FALSE,FALSE,NULL)) == NULL)
      return 0;
    esc.SRB_Cmd=SC_EXEC_SCSI_CMD;
    esc.SRB_HaId=cdrom[cd].ha_id;
    esc.SRB_Flags=SRB_DIR_OUT|SRB_EVENT_NOTIFY;
    esc.SRB_Hdr_Rsvd=0;
    esc.SRB_Target=cdrom[cd].scsi_id;
    esc.SRB_Lun=cdrom[cd].lun;
    esc.SRB_BufLen=8;
    esc.SRB_BufPointer=plextorbuf;
    esc.SRB_SenseLen=SENSE_LEN;
    esc.SRB_CDBLen=6;
    esc.SRB_PostProc=ASPICompletionEvent;
    esc.SRB_CDBByte[0]=0x15;
    esc.SRB_CDBByte[1]=cdrom[cd].lun<<5;
    esc.SRB_CDBByte[2]=0;
    esc.SRB_CDBByte[3]=0;
    esc.SRB_CDBByte[4]=8;
    esc.SRB_CDBByte[5]=0;
    if (speed==1)
      plextorbuf[6]=0;
    else
      plextorbuf[6]=speed/2;
  }
  else if (cdrom[cd].speedselect==SL_HP4020 || cdrom[cd].speedselect==SL_HP6020)
  {
    if ((ASPICompletionEvent = CreateEvent(NULL,FALSE,FALSE,NULL)) == NULL)
      return 0;
    esc.SRB_Cmd=SC_EXEC_SCSI_CMD;
    esc.SRB_HaId=cdrom[cd].ha_id;
    esc.SRB_Flags=SRB_DIR_OUT|SRB_EVENT_NOTIFY;
    esc.SRB_Hdr_Rsvd=0;
    esc.SRB_Target=cdrom[cd].scsi_id;
    esc.SRB_Lun=cdrom[cd].lun;
    esc.SRB_BufLen=12;
    esc.SRB_BufPointer=hpbuf;
    esc.SRB_SenseLen=SENSE_LEN;
    esc.SRB_CDBLen=6;
    esc.SRB_PostProc=ASPICompletionEvent;
    esc.SRB_CDBByte[0]=0x15;
    esc.SRB_CDBByte[1]=cdrom[cd].lun<<5;
    esc.SRB_CDBByte[2]=0;
    esc.SRB_CDBByte[3]=0;
    esc.SRB_CDBByte[4]=0x0c;
    esc.SRB_CDBByte[5]=0;
    if (cdrom[cd].speedselect==SL_HP4020)
      hpbuf[6]=speed;
    else if (cdrom[cd].speedselect==SL_HP6020)
      hpbuf[8]=speed;
  }
  else if (cdrom[cd].speedselect==SL_GENERIC)
  {
    if ((ASPICompletionEvent = CreateEvent(NULL,FALSE,FALSE,NULL)) == NULL)
      return 0;
    esc.SRB_Cmd=SC_EXEC_SCSI_CMD;
    esc.SRB_HaId=cdrom[cd].ha_id;
    esc.SRB_Flags=SRB_DIR_OUT|SRB_EVENT_NOTIFY;
    esc.SRB_Hdr_Rsvd=0;
    esc.SRB_Target=cdrom[cd].scsi_id;
    esc.SRB_Lun=cdrom[cd].lun;
    esc.SRB_BufLen=0;
    esc.SRB_BufPointer=NULL;
    esc.SRB_SenseLen=SENSE_LEN;
    esc.SRB_CDBLen=12;
    esc.SRB_PostProc=ASPICompletionEvent;
    esc.SRB_CDBByte[0]=0xbb;
    esc.SRB_CDBByte[1]=cdrom[cd].lun<<5;
    if (speed==cdrom[cd].speed[0])
    {
      esc.SRB_CDBByte[2]=0xff;
      esc.SRB_CDBByte[3]=0xff;
    }
    else
    {
      esc.SRB_CDBByte[2]=(char)(((((long)speed*2352L*75L)/1000L)>>8)&0xff);
      esc.SRB_CDBByte[3]=(char)((((long)speed*2352L*75L)/1000L)&0xff);
    }
    esc.SRB_CDBByte[4]=0xff;
    esc.SRB_CDBByte[5]=0xff;
    esc.SRB_CDBByte[6]=0;
    esc.SRB_CDBByte[7]=0;
    esc.SRB_CDBByte[8]=0;
    esc.SRB_CDBByte[9]=0;
    esc.SRB_CDBByte[10]=0;
    esc.SRB_CDBByte[11]=0;
  }
  else if (cdrom[cd].speedselect==SL_ATAPI)
  {
    if ((ASPICompletionEvent = CreateEvent(NULL,FALSE,FALSE,NULL)) == NULL)
      return 0;
    esc.SRB_Cmd=SC_EXEC_SCSI_CMD;
    esc.SRB_HaId=cdrom[cd].ha_id;
    esc.SRB_Flags=SRB_DIR_OUT|SRB_EVENT_NOTIFY;
    esc.SRB_Hdr_Rsvd=0;
    esc.SRB_Target=cdrom[cd].scsi_id;
    esc.SRB_Lun=cdrom[cd].lun;
    esc.SRB_BufLen=0;
    esc.SRB_BufPointer=NULL;
    esc.SRB_SenseLen=SENSE_LEN;
    esc.SRB_CDBLen=12;
    esc.SRB_PostProc=ASPICompletionEvent;
    esc.SRB_CDBByte[0]=0xbb;
    esc.SRB_CDBByte[1]=cdrom[cd].lun<<5;
    if (speed==cdrom[cd].speed[0])
    {
      esc.SRB_CDBByte[2]=0xff;
      esc.SRB_CDBByte[3]=0xff;
    }
    else
    {
	    if (speed&1) /* not even */
		    kspeed=176*speed;
      else
        kspeed=353*(speed/2);
      esc.SRB_CDBByte[2]=(char)((kspeed>>8)&0xff);
      esc.SRB_CDBByte[3]=(char)(kspeed&0xff);
    }
    esc.SRB_CDBByte[4]=0;
    esc.SRB_CDBByte[5]=0;
    esc.SRB_CDBByte[6]=0;
    esc.SRB_CDBByte[7]=0;
    esc.SRB_CDBByte[8]=0;
    esc.SRB_CDBByte[9]=0;
    esc.SRB_CDBByte[10]=0;
    esc.SRB_CDBByte[11]=0;
  }
  else // Don't know the commands for other vendors
    return 1;
  SendASPI32Command(&esc);
  ASPIEventStatus = WaitForSingleObject(ASPICompletionEvent, TIMEOUT);

  if (ASPIEventStatus == WAIT_OBJECT_0)
     ResetEvent(ASPICompletionEvent);
  CloseHandle(ASPICompletionEvent);
  if (esc.SRB_Status!=1 || esc.SRB_HaStat!=0 || esc.SRB_HaStat!=0)
    return 0;
  return 1;
}
  
void CalculateSpeeds(int cd,int speed)
{
  int n=0;

  switch (speed)
  {
    case 20:
      cdrom[cd].speed[n++]=20;
      cdrom[cd].speed[n++]=8;
      cdrom[cd].speed[n++]=4;
      cdrom[cd].speed[n++]=2;
      cdrom[cd].speed[n++]=1;
      break;
    case 12:
      cdrom[cd].speed[n++]=12;
      cdrom[cd].speed[n++]=8;
      cdrom[cd].speed[n++]=4;
      cdrom[cd].speed[n++]=2;
      cdrom[cd].speed[n++]=1;
      break;
    case 8:
      cdrom[cd].speed[n++]=8;
      cdrom[cd].speed[n++]=4;
      cdrom[cd].speed[n++]=2;
      cdrom[cd].speed[n++]=1;
      break;
    case 6:
      cdrom[cd].speed[n++]=6;
      cdrom[cd].speed[n++]=2;
      cdrom[cd].speed[n++]=1;
      break;
    case 4:
      cdrom[cd].speed[n++]=4;
      cdrom[cd].speed[n++]=2;
      cdrom[cd].speed[n++]=1;
      break;
    case 3:
      cdrom[cd].speed[n++]=3;
      cdrom[cd].speed[n++]=2;
      cdrom[cd].speed[n++]=1;
      break;
    case 2:
      cdrom[cd].speed[n++]=2;
      cdrom[cd].speed[n++]=1;
      break;
    case 1:
      cdrom[cd].speed[n++]=1;
      break;
    default:
      while (speed)
      {
        cdrom[cd].speed[n]=speed;
        speed=speed/2;
        if (speed>1)
          speed=(speed/2)*2;
        n++;
      }
  }
  cdrom[cd].nspeeds=n;
}

void GetCDRomDrives(HWND hWnd)
{
  SRB_HAInquiry hai;
  SRB_ExecSCSICmd esc;
  int x,y;
  char buf[56],vid[9],pid[17],tmp[40];
  HANDLE ASPICompletionEvent;
  DWORD ASPIEventStatus;

  luns=LOBYTE(LOWORD(GetASPI32SupportInfo()));
  for (x=0;x<luns;x++)
  {
    hai.SRB_Cmd=SC_HA_INQUIRY;
    hai.SRB_HaId=x;
    hai.SRB_Flags=0;
    hai.SRB_Hdr_Rsvd=0;
    SendASPI32Command(&hai);
    for (y=0;y<hai.HA_Unique[3];y++)
    {
      if ((ASPICompletionEvent = CreateEvent(NULL,FALSE,FALSE,NULL)) == NULL)
        return;
      esc.SRB_Cmd=SC_EXEC_SCSI_CMD;
      esc.SRB_HaId=x;
      esc.SRB_Flags=SRB_DIR_IN|SRB_EVENT_NOTIFY;
      esc.SRB_Hdr_Rsvd=0;
      esc.SRB_Target=y;
      esc.SRB_Lun=0;
      esc.SRB_BufLen=32;
      esc.SRB_BufPointer=buf;
      esc.SRB_SenseLen=SENSE_LEN;
      esc.SRB_CDBLen=6;
      esc.SRB_PostProc=ASPICompletionEvent;
      esc.SRB_CDBByte[0]=0x12;
      esc.SRB_CDBByte[1]=x<<5;
      esc.SRB_CDBByte[2]=0;
      esc.SRB_CDBByte[3]=0;
      esc.SRB_CDBByte[4]=32;
      esc.SRB_CDBByte[5]=0;
      SendASPI32Command(&esc);
      ASPIEventStatus = WaitForSingleObject(ASPICompletionEvent, TIMEOUT);

      if (ASPIEventStatus == WAIT_OBJECT_0)
         ResetEvent(ASPICompletionEvent);
      CloseHandle(ASPICompletionEvent);
      if (esc.SRB_Status==1 && esc.SRB_HaStat==0 && ((buf[0]&0x1f)==0x05 || buf[0]==0x7f)) // CDROM or CDWRITER
      {
	      strncpy(vid,&buf[8],8);
	      vid[8]=0;
        strncpy(pid,&buf[16],16);
      	pid[16]=0;
	      {
	        cdrom[n_cdrom].lun=0;
	        cdrom[n_cdrom].scsi_id=y;
	        cdrom[n_cdrom].ha_id=x;
	        if (!strncmp(vid,"PLEXTOR",7))
	        {
	          cdrom[n_cdrom].readmethod=RM_PLEXTOR;
	          cdrom[n_cdrom].modeselect=MS_GENERAL;
			      if (!strstr(pid,"CD-ROM"))
            {
				      cdrom[n_cdrom].speedselect=SL_GENERIC;
	            CalculateSpeeds(n_cdrom,12);
            }
			      else
            {
  	          cdrom[n_cdrom].speedselect=SL_PLEXTOR;
              cdrom[n_cdrom].bigendian=0;
              cdrom[n_cdrom].jitter=0;
	            if (strstr(pid,"32"))
  	            CalculateSpeeds(n_cdrom,20);
	            else if (strstr(pid,"20"))
  	            CalculateSpeeds(n_cdrom,12);
	            else if (strstr(pid,"12"))
  	            CalculateSpeeds(n_cdrom,8);
	            else if (strstr(pid,"8"))
  	            CalculateSpeeds(n_cdrom,8);
	            else if (strstr(pid,"6"))
  	            CalculateSpeeds(n_cdrom,6);
	            else if (strstr(pid,"4"))
  	            CalculateSpeeds(n_cdrom,4);
	            else
	              CalculateSpeeds(n_cdrom,2);
            }
	        }
	        else if (!strncmp(vid,"HP",2))
	        {
	          cdrom[n_cdrom].readmethod=RM_GENERAL;
	          cdrom[n_cdrom].modeselect=MS_GENERAL;
  	          cdrom[n_cdrom].bigendian=1;
  	          cdrom[n_cdrom].jitter=0;
	          if (strstr(pid,"4324") || strstr (pid,"4325"))
	          {
 	            cdrom[n_cdrom].speedselect=SL_HP4020;
	            CalculateSpeeds(n_cdrom,4);
	          }
	          else if (strstr(pid,"6020"))
	          {
 	            cdrom[n_cdrom].speedselect=SL_HP6020;
	            CalculateSpeeds(n_cdrom,6);
	          }
	        }
	        else if (!strncmp(vid,"TOSHIBA",7))
	        {
	          cdrom[n_cdrom].readmethod=RM_TOSHIBA;
	          cdrom[n_cdrom].modeselect=MS_TOSHIBA;
	          cdrom[n_cdrom].speedselect=SL_GENERIC;
                  CalculateSpeeds(n_cdrom,0);
  	          cdrom[n_cdrom].bigendian=0;
  	          cdrom[n_cdrom].jitter=0;
	        }
	        else if (!strncmp(vid,"HITACHI",7))
	        {
	          cdrom[n_cdrom].readmethod=RM_GENERAL;
	          cdrom[n_cdrom].modeselect=MS_GENERAL;
	          cdrom[n_cdrom].speedselect=SL_GENERIC;
                  CalculateSpeeds(n_cdrom,0);
  	          cdrom[n_cdrom].bigendian=1;
  	          cdrom[n_cdrom].jitter=0;
	        }
	        else if (!strncmp(vid,"SONY",4))
	        {
	          cdrom[n_cdrom].readmethod=RM_PLEXTOR;
	          cdrom[n_cdrom].modeselect=MS_GENERAL;
	          cdrom[n_cdrom].speedselect=SL_GENERIC;
                  CalculateSpeeds(n_cdrom,0);
  	          cdrom[n_cdrom].bigendian=0;
  	          cdrom[n_cdrom].jitter=0;
	        }
	        else if (!strncmp(vid,"NEC",3))
	        {
	          cdrom[n_cdrom].readmethod=RM_NEC;
	          cdrom[n_cdrom].modeselect=MS_GENERAL;
	          cdrom[n_cdrom].speedselect=SL_GENERIC;
                  CalculateSpeeds(n_cdrom,0);
  	          cdrom[n_cdrom].bigendian=0;
  	          cdrom[n_cdrom].jitter=0;
	        }
	        else if (!strncmp(vid,"DEC",3))
	        {
	          cdrom[n_cdrom].readmethod=RM_GENERAL;
	          cdrom[n_cdrom].modeselect=MS_TOSHIBA;
	          cdrom[n_cdrom].speedselect=SL_GENERIC;
                  CalculateSpeeds(n_cdrom,0);
  	          cdrom[n_cdrom].bigendian=0;
  	          cdrom[n_cdrom].jitter=0;
	        }
	        else if (!strncmp(vid,"IMS",3))
	        {
	          cdrom[n_cdrom].readmethod=RM_GENERAL;
	          cdrom[n_cdrom].modeselect=MS_GENERAL;
	          cdrom[n_cdrom].speedselect=SL_GENERIC;
                  CalculateSpeeds(n_cdrom,0);
  	          cdrom[n_cdrom].bigendian=1;
  	          cdrom[n_cdrom].jitter=0;
	        }
	        else if (!strncmp(vid,"KODAK",5))
	        {
	          cdrom[n_cdrom].readmethod=RM_GENERAL;
	          cdrom[n_cdrom].modeselect=MS_GENERAL;
	          cdrom[n_cdrom].speedselect=SL_GENERIC;
                  CalculateSpeeds(n_cdrom,0);
  	          cdrom[n_cdrom].bigendian=1;
  	          cdrom[n_cdrom].jitter=0;
	        }
	        else if (!strncmp(vid,"PHILIPS",7))
	        {
	          cdrom[n_cdrom].readmethod=RM_GENERAL;
	          cdrom[n_cdrom].modeselect=MS_GENERAL;
	          cdrom[n_cdrom].speedselect=SL_GENERIC;
                  CalculateSpeeds(n_cdrom,0);
  	          cdrom[n_cdrom].bigendian=1;
  	          cdrom[n_cdrom].jitter=0;
	        }
	        else if (!strncmp(vid,"PLASMON",7))
	        {
	          cdrom[n_cdrom].readmethod=RM_GENERAL;
	          cdrom[n_cdrom].modeselect=MS_GENERAL;
	          cdrom[n_cdrom].speedselect=SL_GENERIC;
                  CalculateSpeeds(n_cdrom,0);
  	          cdrom[n_cdrom].bigendian=1;
  	          cdrom[n_cdrom].jitter=0;
	        }
	        else if (!strncmp(vid,"YAMAHA",6))
	        {
	          cdrom[n_cdrom].readmethod=RM_PLEXTOR;
	          cdrom[n_cdrom].modeselect=MS_GENERAL;
	          cdrom[n_cdrom].speedselect=SL_GENERIC;
                  CalculateSpeeds(n_cdrom,0);
  	          cdrom[n_cdrom].bigendian=0;
  	          cdrom[n_cdrom].jitter=0;
	        }
	        else if (!strncmp(vid,"GRUNDIG",7) && !strncmp(pid,"CDR",3))
	        {
	          cdrom[n_cdrom].readmethod=RM_GENERAL;
	          cdrom[n_cdrom].modeselect=MS_GENERAL;
	          cdrom[n_cdrom].speedselect=SL_GENERIC;
                  CalculateSpeeds(n_cdrom,0);
  	          cdrom[n_cdrom].bigendian=1;
  	          cdrom[n_cdrom].jitter=0;
	        }
	        else if (!strncmp(vid,"MITSUMI",7) && !strncmp(pid,"CD-R",4))
	        {
	          cdrom[n_cdrom].readmethod=RM_GENERAL;
	          cdrom[n_cdrom].modeselect=MS_GENERAL;
	          cdrom[n_cdrom].speedselect=SL_GENERIC;
                  CalculateSpeeds(n_cdrom,0);
  	          cdrom[n_cdrom].bigendian=1;
  	          cdrom[n_cdrom].jitter=0;
	        }
	        else
	        {
	          cdrom[n_cdrom].readmethod=RM_GENERAL;
	          cdrom[n_cdrom].modeselect=MS_GENERAL;
	          cdrom[n_cdrom].speedselect=SL_GENERIC;
            CalculateSpeeds(n_cdrom,0);
  	        cdrom[n_cdrom].bigendian=0;
  	        cdrom[n_cdrom].jitter=0;
	        }
	        sprintf(tmp,"%8s %16s SCSI id %d",vid,pid,y);
	        SendDlgItemMessage(hWnd,IDC_SOURCE,CB_INSERTSTRING,n_cdrom,(LPARAM)tmp);
          strcpy(cdrom[n_cdrom].desc,tmp);
	        n_cdrom++;
	        if (n_cdrom==1)
	          SendDlgItemMessage(hWnd,IDC_SOURCE,CB_SETCURSEL,0,0);
	      }
      }
    }
  }
  if (n_cdrom)
  {
    ReadTOC(hWnd,0,0);
    ReadCDSettings(0,cdrom[0].desc);
    ShowSpeeds(hWnd,0);
  }
}

void ReadTOC(HWND hWnd,int cd,int compare)
{
  SRB_ExecSCSICmd esc;
  HANDLE ASPICompletionEvent;
  DWORD ASPIEventStatus;
  int x,retries=0;
  long low,high,seconds;
  char tmp[40];
  TOC toc2;

  if (cd>=n_cdrom)
    return;
  while (retries<10)
  {
    if ((ASPICompletionEvent = CreateEvent(NULL,FALSE,FALSE,NULL)) == NULL)
      return;
    esc.SRB_Cmd=SC_EXEC_SCSI_CMD;
    esc.SRB_HaId=cdrom[cd].ha_id;
    esc.SRB_Flags=SRB_DIR_IN|SRB_EVENT_NOTIFY;
    esc.SRB_Hdr_Rsvd=0;
    esc.SRB_Target=cdrom[cd].scsi_id;
    esc.SRB_Lun=cdrom[cd].lun;
    esc.SRB_BufLen=sizeof(TOC);
    esc.SRB_BufPointer=(char*)&toc2;
    esc.SRB_SenseLen=SENSE_LEN;
    esc.SRB_CDBLen=10;
    esc.SRB_PostProc=ASPICompletionEvent;
    esc.SRB_CDBByte[0]=0x43;
    esc.SRB_CDBByte[1]=cdrom[cd].lun<<5;
    esc.SRB_CDBByte[2]=0;
    esc.SRB_CDBByte[3]=0;
    esc.SRB_CDBByte[4]=0;
    esc.SRB_CDBByte[5]=0;
    esc.SRB_CDBByte[6]=0;
    esc.SRB_CDBByte[7]=HIBYTE(sizeof(TOC));
    esc.SRB_CDBByte[8]=LOBYTE(sizeof(TOC));
    esc.SRB_CDBByte[9]=0;
    SendASPI32Command(&esc);
    ASPIEventStatus = WaitForSingleObject(ASPICompletionEvent, TIMEOUT);

    if (ASPIEventStatus == WAIT_OBJECT_0)
       ResetEvent(ASPICompletionEvent);
    CloseHandle(ASPICompletionEvent);
    if (esc.SRB_Status==1 && (esc.SRB_HaStat==0 || esc.SRB_HaStat==0x12))
    {
      if (!compare || memcmp(toc.tracks,toc2.tracks,(toc2.last_track-toc2.first_track)*sizeof(TrackDef)))
      {
        memcpy(&toc,&toc2,sizeof(TOC));
        SendDlgItemMessage(hWnd,IDC_TRACKS,LB_RESETCONTENT,0,0);
        for (x=0;x<=toc.last_track-toc.first_track;x++)
        {
	        low=toc.tracks[x].address1<<24|toc.tracks[x].address2<<16|toc.tracks[x].address3<<8|toc.tracks[x].address4;
	        high=toc.tracks[x+1].address1<<24|toc.tracks[x+1].address2<<16|toc.tracks[x+1].address3<<8|toc.tracks[x+1].address4;
	        seconds=(((high-low)*(unsigned long)SECTOR_SIZE)/4)/44100L;
	        sprintf(tmp,"%02d    -    %06lu    -    %05.1f    -    %02lu:%02lu",toc.tracks[x].track,low,(((float)(high-low)*(unsigned long)SECTOR_SIZE)/1024.0)/1024.0,seconds/60,seconds%60);
	        SendDlgItemMessage(hWnd,IDC_TRACKS,LB_INSERTSTRING,x,(LPARAM)tmp);
        }
      }
      retries=0;
      break;
    }
    else
      retries++;
  }
  if (retries>=10)
  {
    SendDlgItemMessage(hWnd,IDC_TRACKS,LB_RESETCONTENT,0,0);
    memset(&toc,0,sizeof(TOC));
  }
}

int ModeSelect(HWND hWnd,int cd,int long_data)
{
  unsigned char buf[12]={0x00,0x00,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x09,0x30};
  SRB_ExecSCSICmd esc;
  HANDLE ASPICompletionEvent;
  DWORD ASPIEventStatus;

  if (cdrom[cd].modeselect==MS_NONE)
    return 1;
  if ((ASPICompletionEvent = CreateEvent(NULL,FALSE,FALSE,NULL)) == NULL)
    return 0;
  if (!long_data)
  {
    buf[10]=0x08;
    buf[11]=0x00;
  }
  else
  {
    if (cdrom[cd].modeselect==MS_TOSHIBA)
      buf[4]=0x82;
  }
  esc.SRB_Cmd=SC_EXEC_SCSI_CMD;
  esc.SRB_HaId=cdrom[cd].ha_id;
  esc.SRB_Flags=SRB_DIR_OUT|SRB_EVENT_NOTIFY;
  esc.SRB_Hdr_Rsvd=0;
  esc.SRB_Target=cdrom[cd].scsi_id;
  esc.SRB_Lun=cdrom[cd].lun;
  esc.SRB_BufLen=12;
  esc.SRB_BufPointer=buf;
  esc.SRB_SenseLen=SENSE_LEN;
  esc.SRB_CDBLen=6;
  esc.SRB_PostProc=ASPICompletionEvent;
  esc.SRB_CDBByte[0]=0x15;
  if (cdrom[cd].modeselect==MS_TOSHIBA)
    esc.SRB_CDBByte[1]=0x10;
  else
    esc.SRB_CDBByte[1]=0;
  esc.SRB_CDBByte[2]=0;
  esc.SRB_CDBByte[3]=0;
  esc.SRB_CDBByte[4]=0x0c;
  esc.SRB_CDBByte[5]=0;
  SendASPI32Command(&esc);
  ASPIEventStatus = WaitForSingleObject(ASPICompletionEvent, TIMEOUT);
  if (ASPIEventStatus == WAIT_OBJECT_0)
     ResetEvent(ASPICompletionEvent);
  CloseHandle(ASPICompletionEvent);
  return 1;
}

void EnQueue(char *buf,unsigned long size)
{
  long sz,x;
  static int last_sz=-1;
  char tmpstr[10];

  for (x=0;x<(int)(size);x++)
  {
    while (!stopthread1 && WaitForSingleObject(increase_sem,1000)==WAIT_TIMEOUT);
    if (stopthread1)
      return;
    if (ReleaseSemaphore(decrease_sem,1,NULL)==0)
      DisplayLastError(whWnd);
    memcpy(&buffer[lastpos*SECTOR_SIZE],&buf[x*SECTOR_SIZE],SECTOR_SIZE);
    lastpos=(lastpos+1)%BUFSIZE;
    qsize++;
  }
    sz=(int)((float)qsize*100.0/(float)BUFSIZE);
    if (sz!=last_sz)
    {
      sprintf(tmpstr,"%d%%",sz);
      SendDlgItemMessage(whWnd,IDC_BUFFERSIZE,WM_SETTEXT,0,(LPARAM)tmpstr);
      last_sz=sz;
    }
}

void DeQueue(char *buf,unsigned long size)
{
  long x;

  for (x=0;x<(int)(size);x++)
  {
    while (!stopthread1 && WaitForSingleObject(decrease_sem,1000)==WAIT_TIMEOUT)
    if (stopthread1)
      return;
    if (ReleaseSemaphore(increase_sem,1,NULL)==0)
      DisplayLastError(whWnd);
    if (stopthread1)
      return;
    memcpy(&buf[x*SECTOR_SIZE],&buffer[firstpos*SECTOR_SIZE],SECTOR_SIZE);
    firstpos=(firstpos+1)%BUFSIZE;
    qsize--;
  }
}

int ReadSector(HWND hWnd,int cd,unsigned long sector,char *buf)
{
  int ok;
  SRB_ExecSCSICmd esc;
  HANDLE ASPICompletionEvent;
  DWORD ASPIEventStatus;
  int count=0,curspeed=speed-1;
  unsigned long size;

  ok=0;
  if (sector+(unsigned long)NSECTORS>high)
    size=high-sector;
  else
    size=NSECTORS;
  if (cdrom[cd].jitter && sector!=low && sector>OVERLAP)
  {
    sector-=OVERLAP;
    size+=OVERLAP;
  }
  if (skiperror)
  {
    EnableWindow(GetDlgItem(hWnd,IDSKIPERROR),FALSE);
    skiperror=0;
  }
  while (!ok && !stopthread1 && !skiperror)
  {
    if ((ASPICompletionEvent = CreateEvent(NULL,FALSE,FALSE,NULL)) == NULL)
      return 0;
    esc.SRB_Cmd=SC_EXEC_SCSI_CMD;
    esc.SRB_HaId=cdrom[cd].ha_id;
    esc.SRB_Flags=SRB_DIR_IN|SRB_EVENT_NOTIFY;
    esc.SRB_Hdr_Rsvd=0;
    esc.SRB_Target=cdrom[cd].scsi_id;
    esc.SRB_Lun=cdrom[cd].lun;
    esc.SRB_BufLen=size*SECTOR_SIZE;
    esc.SRB_BufPointer=buf;
    esc.SRB_SenseLen=SENSE_LEN;
    if (cdrom[cd].readmethod==RM_PLEXTOR)
    {
      esc.SRB_CDBLen=12;
      esc.SRB_PostProc=ASPICompletionEvent;
      esc.SRB_CDBByte[0]=0xd8;
      esc.SRB_CDBByte[1]=cdrom[cd].lun<<5;
      esc.SRB_CDBByte[2]=(unsigned char)(sector>>24)&0xff;
      esc.SRB_CDBByte[3]=(unsigned char)(sector>>16)&0xff;
      esc.SRB_CDBByte[4]=(unsigned char)(sector>>8)&0xff;
      esc.SRB_CDBByte[5]=(unsigned char)(sector&0xff);
      esc.SRB_CDBByte[6]=0;
      esc.SRB_CDBByte[7]=0;
      esc.SRB_CDBByte[8]=0;
      esc.SRB_CDBByte[9]=(unsigned char)size;
      esc.SRB_CDBByte[10]=0;
      esc.SRB_CDBByte[11]=0;
    }
    else if (cdrom[cd].readmethod==RM_GENERAL)
    {
      esc.SRB_CDBLen=10;
      esc.SRB_PostProc=ASPICompletionEvent;
      esc.SRB_CDBByte[0]=0x28;
      esc.SRB_CDBByte[1]=cdrom[cd].lun<<5;
      esc.SRB_CDBByte[2]=(unsigned char)(sector>>24)&0xff;
      esc.SRB_CDBByte[3]=(unsigned char)(sector>>16)&0xff;
      esc.SRB_CDBByte[4]=(unsigned char)(sector>>8)&0xff;
      esc.SRB_CDBByte[5]=(unsigned char)(sector&0xff);
      esc.SRB_CDBByte[6]=0;
      esc.SRB_CDBByte[7]=0;
      esc.SRB_CDBByte[8]=(unsigned char)size;
      esc.SRB_CDBByte[9]=0;
    }
    else if (cdrom[cd].readmethod==RM_NEC)
    {
      esc.SRB_CDBLen=10;
      esc.SRB_PostProc=ASPICompletionEvent;
      esc.SRB_CDBByte[0]=0xd4;
      esc.SRB_CDBByte[1]=cdrom[cd].lun<<5;
      esc.SRB_CDBByte[2]=(unsigned char)(sector>>24)&0xff;
      esc.SRB_CDBByte[3]=(unsigned char)(sector>>16)&0xff;
      esc.SRB_CDBByte[4]=(unsigned char)(sector>>8)&0xff;
      esc.SRB_CDBByte[5]=(unsigned char)(sector&0xff);
      esc.SRB_CDBByte[6]=0;
      esc.SRB_CDBByte[7]=0;
      esc.SRB_CDBByte[8]=(unsigned char)size;
      esc.SRB_CDBByte[9]=0;
    }
    else if (cdrom[cd].readmethod==RM_TOSHIBA)
    {
      esc.SRB_CDBLen=6;
      esc.SRB_PostProc=ASPICompletionEvent;
      esc.SRB_CDBByte[0]=0x08;
      esc.SRB_CDBByte[1]=(unsigned char)(sector>>16)&0xff;
      esc.SRB_CDBByte[2]=(unsigned char)(sector>>8)&0xff;
      esc.SRB_CDBByte[3]=(unsigned char)(sector&0xff);
      esc.SRB_CDBByte[4]=(unsigned char)size;
      esc.SRB_CDBByte[5]=0;
    }
    else if (cdrom[cd].readmethod==RM_ATAPI)
    {
      esc.SRB_CDBLen=12;
      esc.SRB_PostProc=ASPICompletionEvent;
      esc.SRB_CDBByte[0]=0xbe;
      esc.SRB_CDBByte[1]=cdrom[cd].lun<<5;
      esc.SRB_CDBByte[2]=(unsigned char)(sector>>24)&0xff;
      esc.SRB_CDBByte[3]=(unsigned char)(sector>>16)&0xff;
      esc.SRB_CDBByte[4]=(unsigned char)(sector>>8)&0xff;
      esc.SRB_CDBByte[5]=(unsigned char)(sector&0xff);
      esc.SRB_CDBByte[6]=0;
      esc.SRB_CDBByte[7]=0;
      esc.SRB_CDBByte[8]=(unsigned char)size;
      esc.SRB_CDBByte[9]=0x10;
      esc.SRB_CDBByte[10]=0;
      esc.SRB_CDBByte[11]=0;
    }

    SendASPI32Command(&esc);
    ASPIEventStatus = WaitForSingleObject(ASPICompletionEvent, TIMEOUT);

    if (ASPIEventStatus == WAIT_OBJECT_0)
       ResetEvent(ASPICompletionEvent);
    CloseHandle(ASPICompletionEvent);
    if (esc.SRB_Status!=1 || esc.SRB_HaStat || esc.SRB_TargStat)
    {
      EnableWindow(GetDlgItem(hWnd,IDSKIPERROR),TRUE);
      count++;
      sprintf(tmp,"Read errors: %d",count);
      SendDlgItemMessage(hWnd,IDC_VERIFY_TEXT,WM_SETTEXT,0,(LPARAM)tmp);
      if (count%10==0 && cdrom[cd].nspeeds)
      {
      	curspeed++;
	      if (curspeed>=cdrom[cd].nspeeds || curspeed<0)
	        curspeed=0;
	      SetSpeed(cd,cdrom[cd].speed[curspeed]);
        sprintf(tmp,"%u",cdrom[cd].speed[curspeed]);
        SendDlgItemMessage(hWnd,IDC_GRAB_SPEED,WM_SETTEXT,0,(LPARAM)tmp);
      }
      continue;
    }
    else
      ok=1;
  }
  if (count)
  {
    SendDlgItemMessage(hWnd,IDC_VERIFY_TEXT,WM_SETTEXT,0,(LPARAM)"");
    EnableWindow(GetDlgItem(hWnd,IDSKIPERROR),FALSE);
    SetSpeed(cd,actualspeed);
    sprintf(tmp,"%u",actualspeed);
    SendDlgItemMessage(hWnd,IDC_GRAB_SPEED,WM_SETTEXT,0,(LPARAM)tmp);
  }
  if (skiperror)
    return 1;
  if (ok || skiperror)
    EnQueue(buf,size);
  return ok;
}

int SetNextSpeed(int cd,int speed,int *actualspeed)
{
  if (!cdrom[cd].nspeeds)
  {
    *actualspeed=0;
    return 0;
  }
  if (speed>cdrom[cd].nspeeds-1)
    speed=cdrom[cd].nspeeds-1;
  while (SetSpeed(cd,cdrom[cd].speed[speed])==0)
  {
    if (speed==cdrom[cd].nspeeds-1)
      break;
    speed++;
  }
  *actualspeed=cdrom[cd].speed[speed];
  speed++;
  if (speed>=cdrom[cd].nspeeds-1)
    speed=cdrom[cd].nspeeds-1;
  return speed;
}  

int AllZero(char *buf,int bufsize)
{
  int x;

  x=1;
  for (x=0;x<bufsize;x++)
  {
    if (buf[x])
      return 0;
  }
  return 1;
}

void WriteFileBuf(char *filename,char *buf,int bufsize)
{
  FILE *f2;
  int x;

  f2=fopen(filename,"w+");
  for (x=0;x<bufsize;x++)
  {
    if (x%20==0)
      fprintf(f2,"\n%05d: ",x);
    fprintf(f2," %02X",(unsigned char)buf[x]);
  }
  fclose(f2);
}

void SynchronizeBuffer(HANDLE f,char *buf,char *origbuf,int bufsize)
{
  int x;
  DWORD dummy;

  if (ReadFile(f,buf,bufsize,&dummy,NULL)==0)
    return;
  if (!memcmp(buf,origbuf,bufsize))
    return;
  SendDlgItemMessage(whWnd,IDC_VERIFY_TEXT,WM_SETTEXT,0,(LPARAM)"Synchronizing...");
//  WriteFileBuf("f:\\buf.txt",buf,bufsize);
//  WriteFileBuf("f:\\origbuf.txt",origbuf,bufsize);
  while (AllZero(buf,bufsize))
  {
    Log("Synchronize all zeros\n");
    SendDlgItemMessage(whWnd,IDC_VERIFY_TEXT,WM_SETTEXT,0,(LPARAM)"Synchronizing zero buffer...");
    SetFilePointer(f,-(bufsize-SYNCHRO_SIZE),NULL,FILE_CURRENT);
    if (ReadFile(f,buf,bufsize,&dummy,NULL)==0)
      return;
  }
  for (x=0;x<bufsize-SYNCHRO_SIZE;x++)
  {
    if (!memcmp(&buf[x],origbuf,bufsize-x))
    {
      SetFilePointer(f,x,NULL,FILE_CURRENT);
      memmove(buf,&buf[x],bufsize-x);
      memcpy(&buf[bufsize-x],&origbuf[bufsize-x],x);
      SendDlgItemMessage(whWnd,IDC_VERIFY_TEXT,WM_SETTEXT,0,(LPARAM)"Synchronized forward.");
      Log("Synchronize 2 x=%d\n",x);
      return;
    }
    if (!memcmp(buf,&origbuf[x],bufsize-x))
    {
      SetFilePointer(f,-x,NULL,FILE_CURRENT);
      memmove(&buf[x],buf,bufsize-x);
      memcpy(buf,origbuf,x);
      SendDlgItemMessage(whWnd,IDC_VERIFY_TEXT,WM_SETTEXT,0,(LPARAM)"Synchronized backward.");
      Log("Synchronize 1 x=%d\n",x);
      return;
    }
  }
  SendDlgItemMessage(whWnd,IDC_VERIFY_TEXT,WM_SETTEXT,0,(LPARAM)"Synchronize failed.");
  Log("Synchronize FAILED\n");
}

DWORD WINAPI WriteFiles(HWND hWnd)
{
  char *buf,tmp[40];
  char *buf2;
  unsigned long x,size;
  unsigned long bufpos;
  DWORD dummy;
  char t;
  int sync_count=0;

  if ((buf=GlobalAlloc(GMEM_FIXED,DOVERLAP_SIZE))==NULL)
  {
    Error(hWnd,"Out of memory (buf)");
    return 0;
  }
  if ((buf2=GlobalAlloc(GMEM_FIXED,DOVERLAP_SIZE))==NULL)
  {
    Error(hWnd,"Out of memory (buf2)");
    return 0;
  }
  while (!stopthread1 && (!stopthread2 || qsize) && !skipverify)
  {
    if (curpos+DSECTORS>high)
      size=high-curpos;
    else if (stopthread2)
    {
      if (qsize>DSECTORS)
        size=DSECTORS;
      else
        size=qsize;
    }
    else
      size=DSECTORS;
    if (cdrom[cd].jitter && curpos!=low && curpos>OVERLAP)
    {
      size+=OVERLAP;
    }
    if (stopthread1)
      break;
    DeQueue(buf,size);
    if (stopthread1)
      break;
    if (cdrom[cd].bigendian)
    {
      for (x=0;x<size*SECTOR_SIZE;x+=2)
      {
	      t=buf[x];
	      buf[x]=buf[x+1];
	      buf[x+1]=t;
      }
    }
    bufpos=0;
    if (cdrom[cd].jitter)
    {
      if (curpos!=low)
      {
        if (stopthread1)
          break;
	      for (x=0;x<OVERLAP*SECTOR_SIZE*2;x++)
	      {
	        if (!memcmp(&oldbuf[DOVERLAP_SIZE-SYNC_SIZE],&buf[x],SYNC_SIZE))
	        {
	          bufpos=x+SYNC_SIZE;
	          break;
	        }
	      }
	      if (!bufpos)
	        bufpos=OVERLAP*SECTOR_SIZE;
      }
      memcpy(oldbuf,buf,DOVERLAP_SIZE);
    }
    if (!do_compare || !chks)
    {
      if (!stopthread1 && WriteFile(f1,&buf[bufpos],size*SECTOR_SIZE-bufpos,&dummy,NULL)==0)
      {
        DisplayLastError(hWnd);
	      break;
      }
    }
    else
    {
      if (use_tmpfile || (chks&1)==0)
      {
        if (!stopthread1 && WriteFile(f1,&buf[bufpos],size*SECTOR_SIZE-bufpos,&dummy,NULL)==0)
        {
          DisplayLastError(hWnd);
	        break;
        }
      }
      if ((use_tmpfile && chks) || (chks&1)==1)
      {
        if (!synchronized && !AllZero(&buf[bufpos],size*SECTOR_SIZE-bufpos))
        {
          if (stopthread1)
            break;
          SynchronizeBuffer(f2,&buf2[bufpos],&buf[bufpos],size*SECTOR_SIZE-bufpos);
          sync_count++;
          if (sync_count>=3)
            synchronized=1;
        }
        else
        {
          if (!stopthread1 && ReadFile(f2,&buf2[bufpos],size*SECTOR_SIZE-bufpos,&dummy,NULL)==0)
          {
          DisplayLastError(hWnd);
 	          SendDlgItemMessage(hWnd,IDC_VERIFY_TEXT,WM_SETTEXT,0,(LPARAM)"Read error from tmp file");
	          break;
          }
        }
        if (!synchronized && !AllZero(&buf2[bufpos],size*SECTOR_SIZE-bufpos))
        {
          synchronized=0;
        }
        else
        {
	        if (memcmp(&buf[bufpos],&buf2[bufpos],size*SECTOR_SIZE-bufpos))
	        {
	          sprintf(tmp,"Compare error at sector %lu",curpos);
            SendDlgItemMessage(hWnd,IDC_VERIFY_TEXT,WM_SETTEXT,0,(LPARAM)tmp);
            Log("%s\n",tmp);
            error=1;
	          if (!use_tmpfile)
	          {
	            if (autoskip)
	              skipverify=1;
	            else
                EnableWindow(GetDlgItem(hWnd,IDSKIPVERIFY),TRUE);
	          }
	        }
        }
      }
    }
    curpos+=size;
  }
  GlobalFree(buf);
  GlobalFree(buf2);
  thread2stopped=1;
  ExitThread(0);
  return 0;
}

void DisplayProgress(HWND hWnd)
{
  float remaining;
  static float last_time=0,last_remaining=0;
  char tmp[20];
  unsigned long speed;
  DWORD spc,bps,fc,tc,free,freetime;

  end_time=GetTickCount();
  if (start_time!=end_time)
  {
    elapsed=(float)(end_time-start_time)/(float)1000.0;
    if (progress)
    {
      remaining=((((float)100.0-progress)/progress)*elapsed);
      if (remaining!=last_remaining)
      {
        sprintf(tmp,"%02d:%02d",(int)((int)remaining/60),(int)remaining%60);
        SendDlgItemMessage(hWnd,IDC_ETA,WM_SETTEXT,0,(LPARAM)tmp);
      	last_remaining=remaining;
      }
      if (elapsed!=last_time)
      {
        speed=(unsigned long)((((float)(x-low)*(float)SECTOR_SIZE)/1024.0)*1000.0)/(end_time-start_time);
        sprintf(tmp,"%lu",speed);
        SendDlgItemMessage(hWnd,IDC_SPEED,WM_SETTEXT,0,(LPARAM)tmp);
        sprintf(tmp,"%.1f X",(float)speed*1024.0/2352.0/75.0);
        SendDlgItemMessage(hWnd,IDC_SPEED2,WM_SETTEXT,0,(LPARAM)tmp);
        sprintf(tmp,"%02d:%02d",(int)((int)elapsed/60),(int)elapsed%60);
        SendDlgItemMessage(hWnd,IDC_BUSY,WM_SETTEXT,0,(LPARAM)tmp);
        sprintf(tmp,"%02d:%02d",(int)((int)(elapsed+remaining)/60),(int)(elapsed+remaining)%60);
        SendDlgItemMessage(hWnd,IDC_TOTAL,WM_SETTEXT,0,(LPARAM)tmp);
	      last_time=elapsed;
	      GetDiskFreeSpace(drive,&spc,&bps,&fc,&tc);
	      free=fc*spc*bps;
	      if (free>1024L*1024L*1024L)
	        sprintf(tmp,"%.1f G",(float)free/1024.0/1024.0/1024.0);
	      else if (free>1024L*1024L)
	        sprintf(tmp,"%.1f M",(float)free/1024.0/1024.0);
	      else if (free>1024L)
	        sprintf(tmp,"%.1f K",(float)free/1024.0);
	      else
      	  sprintf(tmp,"%lu bytes",free);
        SendDlgItemMessage(hWnd,IDC_DISK_FREE,WM_SETTEXT,0,(LPARAM)tmp);
        freetime=free/4L/44100L;
        sprintf(tmp,"%02d:%02d",(int)(freetime/60),(int)(freetime%60));
        SendDlgItemMessage(hWnd,IDC_FREE_TIME,WM_SETTEXT,0,(LPARAM)tmp);

        free=(tc-fc)*spc*bps;
	      if (free>1024L*1024L*1024L)
	        sprintf(tmp,"%.1f G",(float)free/1024.0/1024.0/1024.0);
	      else if (free>1024L*1024L)
	        sprintf(tmp,"%.1f M",(float)free/1024.0/1024.0);
	      else if (free>1024L)
	        sprintf(tmp,"%.1f K",(float)free/1024.0);
	      else
      	  sprintf(tmp,"%lu bytes",free);
        SendDlgItemMessage(hWnd,IDC_DISK_USED,WM_SETTEXT,0,(LPARAM)tmp);
        freetime=free/4L/44100L;
        sprintf(tmp,"%02d:%02d",(int)(freetime/60),(int)(freetime%60));
        SendDlgItemMessage(hWnd,IDC_USED_TIME,WM_SETTEXT,0,(LPARAM)tmp);

        free=tc*spc*bps;
	      if (free>1024L*1024L*1024L)
	        sprintf(tmp,"%.1f G",(float)free/1024.0/1024.0/1024.0);
	      else if (free>1024L*1024L)
	        sprintf(tmp,"%.1f M",(float)free/1024.0/1024.0);
	      else if (free>1024L)
	        sprintf(tmp,"%.1f K",(float)free/1024.0);
	      else
      	  sprintf(tmp,"%lu bytes",free);
        SendDlgItemMessage(hWnd,IDC_DISK_TOTAL,WM_SETTEXT,0,(LPARAM)tmp);
        freetime=free/4L/44100L;
        sprintf(tmp,"%02d:%02d",(int)(freetime/60),(int)(freetime%60));
        SendDlgItemMessage(hWnd,IDC_TOTAL_TIME,WM_SETTEXT,0,(LPARAM)tmp);
      }
    }
  }
}

void CreateSpeedFilename(char *filename,int actualspeed)
{
  char *tmpstr,tmpfilename[255];

	tmpstr=strrchr(filename,'.');
	if (tmpstr)
	{
	  *tmpstr=0;
	  sprintf(tmpfilename,"%s(%dX).%s",filename,actualspeed,tmpstr+1);
    *tmpstr='.';
	}
  else
    sprintf(tmpfilename,"%s(%dX)",filename,actualspeed);
  strcpy(filename,tmpfilename);
}


DWORD WINAPI GrabTrack(HWND hWnd)
{
  char *buf,*tmpstr;
  char tmppath[MAX_PATH],tempfile[MAX_PATH];
  WaveFile w;
  HANDLE thread2;
  DWORD threadid2;
  DWORD spc,bps,fc,tc,free,dummy;
  struct stat statbuf;
  int y,tracksel[99],sc;
  int option=0;

	if (g_directdisk)
    option=FILE_FLAG_WRITE_THROUGH;
  sc=SendDlgItemMessage(g_hWnd,IDC_TRACKS,LB_GETSELCOUNT,0,0);
	cd=SendDlgItemMessage(g_hWnd,IDC_SOURCE,CB_GETCURSEL,0,0);
	if (cd==CB_ERR)
	{
    ExitThread(0);
    return 0;
	}
  if ((buffer=GlobalAlloc(GMEM_FIXED,BUFSIZE*SECTOR_SIZE))==NULL)
  {
    Error(hWnd,"Out of memory (buffer)");
    ExitThread(0);
    return 0;
  }
  if ((oldbuf=GlobalAlloc(GMEM_FIXED,OVERLAP_SIZE))==NULL)
  {
    Error(hWnd,"Out of memory (oldbuf)");
    ExitThread(0);
    return 0;
  }
  if ((buf=GlobalAlloc(GMEM_FIXED,OVERLAP_SIZE))==NULL)
  {
    Error(hWnd,"Out of memory (buf)");
    ExitThread(0);
    return 0;
  }
	SendDlgItemMessage(g_hWnd,IDC_TRACKS,LB_GETSELITEMS,(WPARAM)99,(LPARAM)tracksel);
	for (y=0;y<sc;y++)
	{
	  if (sc>1)
	  {
	    tmpstr=strrchr(h_filename,'.');
	    if (tmpstr)
	    {
	      *tmpstr=0;
	      sprintf(filename,"%s_%d.%s",h_filename,tracksel[y]+1,tmpstr+1);
      	*tmpstr='.';
	    }
	    else
      	sprintf(filename,"%s_%d",h_filename,tracksel[y]+1);
	  }
	  else
	    strcpy(filename,h_filename);
	  strncpy(drive,filename,3);
	  drive[3]=0;
	  GetDiskFreeSpace(drive,&spc,&bps,&fc,&tc);
	  free=fc*spc*bps;
	  if (!stat(filename,&statbuf))
	    free+=statbuf.st_size;
	  low=toc.tracks[tracksel[y]].address1<<24|toc.tracks[tracksel[y]].address2<<16|toc.tracks[tracksel[y]].address3<<8|toc.tracks[tracksel[y]].address4;
	  high=toc.tracks[tracksel[y]+1].address1<<24|toc.tracks[tracksel[y]+1].address2<<16|toc.tracks[tracksel[y]+1].address3<<8|toc.tracks[tracksel[y]+1].address4;
	  if (free<(high-low)*2352+sizeof(WaveFile))
	  {
	    Error(hWnd,"Not enough disk space available!");
	  }
	  else
	  {
	    track=tracksel[y];
      if (cd>=n_cdrom)
      {
        ExitThread(0);
        GlobalFree(buffer);
        GlobalFree(oldbuf);
        GlobalFree(buf);
        return 0;
      }
      if (!ModeSelect(hWnd,cd,1))
      {
        GlobalFree(buffer);
        GlobalFree(oldbuf);
        GlobalFree(buf);
        ExitThread(0);
        return 0;
      }

      GetTempPath(MAX_PATH,tmppath);
      GetTempFileName(tmppath,"CDRIP",0,tempfile);
      if (use_tmpfile)
      {
        strncpy(buf,tempfile,3);
        buf[4]=0;
        GetDiskFreeSpace(buf,&spc,&bps,&fc,&tc);
        free=fc*spc*bps;
        if (!stat(tempfile,&statbuf))
          free+=statbuf.st_size;
        low=toc.tracks[track].address1<<24|toc.tracks[track].address2<<16|toc.tracks[track].address3<<8|toc.tracks[track].address4;
        high=toc.tracks[track+1].address1<<24|toc.tracks[track+1].address2<<16|toc.tracks[track+1].address3<<8|toc.tracks[track+1].address4;
        if (free<(high-low)*2352+sizeof(WaveFile))
        {
          Error(hWnd,"Not enough temporary disk space available!");
          use_tmpfile=0;
        }
      }
      same=0;
      chks=0;
      error=0;
      extra=0;
      speed=max_speed;
      skipfile=0;
      while (!same && !stopthread1)
      {
	      if (sc>1)
	      {
	        tmpstr=strrchr(h_filename,'.');
	        if (tmpstr)
	        {
	          *tmpstr=0;
	          sprintf(filename,"%s_%d.%s",h_filename,tracksel[y]+1,tmpstr+1);
      	    *tmpstr='.';
	        }
	        else
      	    sprintf(filename,"%s_%d",h_filename,tracksel[y]+1);
	      }
	      else
	        strcpy(filename,h_filename);
        synchronized=0;
        if (!do_compare)
        {
          speed=SetNextSpeed(cd,speed,&actualspeed);
          if (showspeed)
            CreateSpeedFilename(filename,actualspeed);
          f1=CreateFile(filename,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,0,NULL);
          f2=NULL;
          SendDlgItemMessage(hWnd,IDC_TARGET_FILE,WM_SETTEXT,0,(LPARAM)filename);
          SendDlgItemMessage(hWnd,IDC_COMPARE_FILE,WM_SETTEXT,0,(LPARAM)"none");
        }
        else
        {
          if (chks==0)
          {
            speed=SetNextSpeed(cd,speed,&actualspeed);
            if (showspeed)
              CreateSpeedFilename(filename,actualspeed);
            f1=CreateFile(filename,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,option,NULL);
	          f2=NULL;
	          SendDlgItemMessage(hWnd,IDC_TARGET_FILE,WM_SETTEXT,0,(LPARAM)filename);
	          SendDlgItemMessage(hWnd,IDC_COMPARE_FILE,WM_SETTEXT,0,(LPARAM)"none");
          }
          else if (chks&1)
          {
	          if (use_tmpfile)
	          {
              f1=CreateFile(tempfile,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,option,NULL);
	            SendDlgItemMessage(hWnd,IDC_TARGET_FILE,WM_SETTEXT,0,(LPARAM)tempfile);
	          }
	          else
	          {
	            f1=NULL;
	            SendDlgItemMessage(hWnd,IDC_TARGET_FILE,WM_SETTEXT,0,(LPARAM)"none");
	          }
            if (showspeed)
              CreateSpeedFilename(filename,actualspeed);
            f2=CreateFile(filename,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_FLAG_SEQUENTIAL_SCAN,NULL);
      	    SendDlgItemMessage(hWnd,IDC_COMPARE_FILE,WM_SETTEXT,0,(LPARAM)filename);
          }
          else
          {
            speed=SetNextSpeed(cd,speed,&actualspeed);
            if (showspeed)
              CreateSpeedFilename(filename,actualspeed);
	          SendDlgItemMessage(hWnd,IDC_TARGET_FILE,WM_SETTEXT,0,(LPARAM)filename);
            f1=CreateFile(filename,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,option,NULL);
	          if (use_tmpfile)
	          {
              f2=CreateFile(tempfile,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_FLAG_SEQUENTIAL_SCAN,NULL);
  	          SendDlgItemMessage(hWnd,IDC_COMPARE_FILE,WM_SETTEXT,0,(LPARAM)tempfile);
	          }
	          else
	          {
	            f2=NULL;
	            SendDlgItemMessage(hWnd,IDC_COMPARE_FILE,WM_SETTEXT,0,(LPARAM)"none");
	          }
          }
        }
        if (f1 && !f2)
          SetWindowText(hWnd,"Copying track");
        else if (!f1 && f2)
          SetWindowText(hWnd,"Verifying track");
        else
          SetWindowText(hWnd,"Copying and verifying track");
        SendDlgItemMessage(hWnd,IDC_VERIFY_TEXT,WM_SETTEXT,0,(LPARAM)"");

        low=toc.tracks[track].address1<<24|toc.tracks[track].address2<<16|toc.tracks[track].address3<<8|toc.tracks[track].address4;
        high=toc.tracks[track+1].address1<<24|toc.tracks[track+1].address2<<16|toc.tracks[track+1].address3<<8|toc.tracks[track+1].address4;
        sprintf(tmp,"%06lu",low);
        SendDlgItemMessage(hWnd,IDC_LOW,WM_SETTEXT,0,(LPARAM)tmp);
        sprintf(tmp,"%06lu",high);
        SendDlgItemMessage(hWnd,IDC_HIGH,WM_SETTEXT,0,(LPARAM)tmp);
        SendDlgItemMessage(hWnd,IDC_PROGRESS,PBM_SETRANGE,0,MAKELPARAM(0,100));
        sprintf(tmp,"%u",actualspeed);
        SendDlgItemMessage(hWnd,IDC_GRAB_SPEED,WM_SETTEXT,0,(LPARAM)tmp);
        error=0;
        strncpy(w.riff.rID,"RIFF",4);
        w.riff.rLen=(high-low)*SECTOR_SIZE+(unsigned long)sizeof(struct WAVE);
        strncpy(w.wave.wID,"WAVE",4);
        strncpy(w.wave.fmt.fID,"fmt ",4);
        w.wave.fmt.fLen=sizeof(struct FORMAT)-8;
        w.wave.fmt.wTag=1;
        w.wave.fmt.wChannel=2;
        w.wave.fmt.nSample=44100L;
        w.wave.fmt.nByte=44100L*4L;
        w.wave.fmt.align=4;
        w.wave.fmt.sample=16;
        strncpy(w.wave.data.dID,"data",4);
        w.wave.data.dLen=(high-low)*SECTOR_SIZE;
        if (f1)
          WriteFile(f1,&w,sizeof(WaveFile),&dummy,NULL);
        if (f2)
          SetFilePointer(f2,sizeof(WaveFile),NULL,FILE_BEGIN);
        x=low;
        start_time=GetTickCount();
        if ((decrease_sem=CreateSemaphore(NULL,0,BUFSIZE-1,NULL))==NULL)
          DisplayLastError(hWnd);
        if ((increase_sem=CreateSemaphore(NULL,BUFSIZE-1,BUFSIZE-1,NULL))==NULL)
          DisplayLastError(hWnd);
        stopthread2=0;
        skipverify=0;
        thread2=CreateThread(NULL,0,WriteFiles,hWnd,0,&threadid2);
        thread2stopped=0;
        curpos=low;
        firstpos=0;
        lastpos=0;
        qsize=0;
        seconds=(((high-low)*(unsigned long)SECTOR_SIZE)/4L)/44100L;
        sprintf(tmp,"%02ld:%02ld",seconds/60L,seconds%60L);
        SendDlgItemMessage(hWnd,IDC_TIME_TOTAL,WM_SETTEXT,0,(LPARAM)tmp);
        seconds=((high-low)*(unsigned long)SECTOR_SIZE)/1024L;
        sprintf(tmp,"%ld",seconds);
        SendDlgItemMessage(hWnd,IDC_SIZE_TOTAL,WM_SETTEXT,0,(LPARAM)tmp);
        EnableWindow(GetDlgItem(hWnd,IDSKIPERROR),FALSE);
        EnableWindow(GetDlgItem(hWnd,IDSKIPVERIFY),FALSE);
        for (x=low;x<high && !stopthread1 && !skipverify;x+=NSECTORS)
        {
          if (x)
          {
	          sprintf(tmp,"%06lu",x);
	          SendDlgItemMessage(hWnd,IDC_SECTOR,WM_SETTEXT,0,(LPARAM)tmp);
            if (high!=low)
  	          SendDlgItemMessage(hWnd,IDC_PROGRESS,PBM_SETPOS,(WPARAM)((x-low)*100)/(high-low),0);
            seconds=(((x-low)*(unsigned long)SECTOR_SIZE)/4L)/44100L;
            sprintf(tmp,"%02ld:%02ld",seconds/60L,seconds%60L);
	          SendDlgItemMessage(hWnd,IDC_TIME,WM_SETTEXT,0,(LPARAM)tmp);
            seconds=(((high-x)*(unsigned long)SECTOR_SIZE)/4L)/44100L;
            sprintf(tmp,"%02ld:%02ld",seconds/60L,seconds%60L);
	          SendDlgItemMessage(hWnd,IDC_TIME_LEFT,WM_SETTEXT,0,(LPARAM)tmp);
	          seconds=((x-low)*(unsigned long)SECTOR_SIZE)/1024L;
	          sprintf(tmp,"%ld",seconds);
	          SendDlgItemMessage(hWnd,IDC_SIZE_CURRENT,WM_SETTEXT,0,(LPARAM)tmp);
	          seconds=((high-x)*(unsigned long)SECTOR_SIZE)/1024L;
	          sprintf(tmp,"%ld",seconds);
	          SendDlgItemMessage(hWnd,IDC_SIZE_LEFT,WM_SETTEXT,0,(LPARAM)tmp);
            if (high!=low)
  	          progress=(((float)x-(float)low)*(float)100.0)/((float)high-(float)low);
            if (progress!=last_progress)
	          {
	            sprintf(tmp,"%u",(int)progress);
	            SendDlgItemMessage(hWnd,IDC_PERCENT,WM_SETTEXT,0,(LPARAM)tmp);
	            last_progress=progress;
	          }
          }
          if (ReadSector(hWnd,cd,x,buf))
          {
            if (x==low)
    	        start_time=GetTickCount();
          }
        }
        stopthread2=1;
        while (!thread2stopped)
          Sleep(100);
        ReleaseSemaphore(decrease_sem,1,NULL);
        ReleaseSemaphore(increase_sem,1,NULL);
        if (f1)
        {
          strncpy(w.riff.rID,"RIFF",4);
          w.riff.rLen=(SetFilePointer(f1,0,NULL,FILE_CURRENT)-sizeof(WaveFile))+(unsigned long)sizeof(struct WAVE);
          strncpy(w.wave.wID,"WAVE",4);
          strncpy(w.wave.fmt.fID,"fmt ",4);
          w.wave.fmt.fLen=sizeof(struct FORMAT)-8;
          w.wave.fmt.wTag=1;
          w.wave.fmt.wChannel=2;
          w.wave.fmt.nSample=44100L;
          w.wave.fmt.nByte=44100L*4L;
          w.wave.fmt.align=4;
          w.wave.fmt.sample=16;
          strncpy(w.wave.data.dID,"data",4);
          w.wave.data.dLen=SetFilePointer(f1,0,NULL,FILE_CURRENT)-sizeof(WaveFile);
          SetFilePointer(f1,0,NULL,FILE_BEGIN);
          WriteFile(f1,&w,sizeof(WaveFile),&dummy,NULL);
          CloseHandle(f1);
        }
        if (f2)
          CloseHandle(f2);
        if (error || (do_compare && !chks) || (do_compare && !use_tmpfile && (chks&1)==0))
          same=0;
        else
          same=1;
        chks++;
        CloseHandle(decrease_sem);
        CloseHandle(increase_sem);
        if ((!same && (chks&1)==0) || skipverify)
          remove(filename);
      }
      ModeSelect(hWnd,cd,0);
      remove(tempfile);
	  }
    if (skipfile)
      stopthread1=0;
	}
  GlobalFree(buffer);
  GlobalFree(oldbuf);
  GlobalFree(buf);
  ExitThread(0);
  return 0;
}
